//  TopFiles/NT is a bulletinmaker program for the BBBS bulletin board system.
//  Copyright 2001 (c) PowerLink BBS.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  PowerLink can be reached at:
//
//     PowerLink BBS
//
//     Node 1  : 47-38094149 (64k ISDN)
//     Node 2  : 47-38025696 (33k Modem)
//     WWW     : http://home.online.no/~bigerik/
//     E-Mail  : bigerik@online.no
//     Fidonet : 2:211/50 - 2:211/51

#include <stdio.h>
#include <time.h>

#define VERSION "2.0"
#define MAX 17        /* max files to display */
#define INCLUDEFREE 0 /* do not include free files */
#define TOOLONG 62    /* char to add in front of too long lines. 62 = ">" */

#define FILECOL 36    /* cyan    */ /* Alter these to your liking */
#define DLCOL   35    /* magenta */
#define DESCOL  32    /* green   */

FILE *infileh;
char *infilename;
int topc;
int i;

struct toprec {
  char	filename[80];
  char	directory[80];
  char	desc[80];
  int	downloads;
};

struct toprec top20[MAX];
struct toprec temptop;

void help(void)
{ 
  printf ("\r\nTopFiles/NT version %s. Copyright 2001 (c) PowerLink\r\n", VERSION);
  printf ("Free Software under GNU General Public License. NO WARRANTY.\r\n\r\n");
  printf ("Usage:  topfiles [ <filename> | -V | -help ]\r\n\r\n");
  exit(0);
}

void copy(char linje[80], int begin)
{
  int i;
  for (i=begin;i<strlen(linje);i++)
    linje[i-begin] = linje[i];
  linje[i-begin] = '\0';
}

int getint(char linje[80], int begin, int length)
{
  char kkk[80];
  
  strcpy(kkk, linje);
  copy(kkk, 27);
  kkk[4] = '\0';
  while (kkk[0] == ' ')
    copy(kkk, 1);
  return(atoi((char *)kkk));
}

void inode(int offset)
{
  int t;
  for (t=topc-1;t>offset;t--)
  {
    if (offset>=18)
      printf("Error occurred. Dump: topc=%u, t=%u, offset=%u\r\n", topc, t, offset);
    strcpy(top20[t].filename, top20[t-1].filename);
    strcpy(top20[t].directory, top20[t-1].directory);
    top20[t].downloads = top20[t-1].downloads;
    strcpy(top20[t].desc, top20[t-1].desc);
  }
  strcpy(top20[offset].filename, temptop.filename);
  strcpy(top20[offset].directory, temptop.directory);
  top20[offset].downloads=temptop.downloads;
  strcpy(top20[offset].desc, temptop.desc);
  if (topc<=MAX-1)
    topc++;
}
                              
void chktop(void)
{
  int i;
  for (i=0;i<topc;i++)
  {
    if (temptop.downloads>=top20[i].downloads)
    {
      inode(i);
      break;
    }
  }
}

void decodeline(char *line)
{
  if (strstr(line, "Directory: "))
  {
    strcpy(temptop.directory, line);
    temptop.directory[strlen(temptop.directory)-3] = '\0';
    copy(temptop.directory, 11);
    temptop.filename[0] = '\0';
    temptop.desc[0]     = '\0';
    temptop.downloads   = 0;
  } else
  if ( (strlen(line)>2) && (line[1] != ' ') && (line[25] == 'k') )
  {
    strcpy(temptop.filename, line);
    i = 13;
    while (temptop.filename[i] == ' ')
      temptop.filename[i--] = '\0';
    copy(temptop.filename, 1);
    temptop.downloads = getint(line, 22, 4);
    strcpy(temptop.desc, line);
    copy(temptop.desc, 32);
    temptop.desc[41] = '\0';
    chktop();
    temptop.downloads = 0;
    temptop.filename[0]='\0';
    temptop.desc[0]='\0';
  }
}

void header(void)
{
  int t;
  time_t time_now;

  time(&time_now);
  printf("\0m\[2J\[H\[1;37mTop Files \[1;30m(c) 2001 PowerLink  \[1;36mLast Updated \[0;36m%s\r\n", ctime(&time_now));
  printf("\[1;%umF\[0;%umilename \[1mw\[0;%umith \[1mP\[0;%umath               \[1;%umD\[0;%umlds \[1;%umD\[0;%umescription\r\n", FILECOL, FILECOL, FILECOL, FILECOL, DLCOL, DLCOL, DESCOL, DESCOL);
  printf("\[1;30m-------------------------------- ---- -----------------------------------------\[0m\r\n");
}

int main( int argc, char *argv[] )
{
  char *tmp, tmp2[80];

  topc = 1;
 
  if (argc==2)
  {
    if (strcmp(argv[1], "--help") == 0)
    {
      help();
    }
    if ( (strcmp("-v", argv[1]) == 0) || (strcmp("-V", argv[1]) == 0) )
    { 
      printf("TopFiles/L version %s\r\n", VERSION);
      exit(0);
    }
  } else
  { help(); }

  infilename=argv[1];
  
  if ( (infileh = fopen((void *)infilename, "rt")) == NULL)
  {
    printf("\r\nERRORS 1: Can't open the file '%s'.\r\n\r\n", infilename);
    exit(1);
  }
  
  while (!feof(infileh))
  {
    fgets(tmp2, 80, infileh);
    if (strlen(tmp2) > 2)
    {
      tmp2[strlen(tmp2)-1] = '\0';
      if ( (tmp2[0]!='+') || (INCLUDEFREE == 1) )
        decodeline(tmp2);
    }
  }
  fclose(infileh);

  header();

  for (i=0;i<MAX;i++)
  {
    if (strlen(top20[i].directory) + strlen(top20[i].filename) > 31)
    {
      copy(top20[i].directory, strlen(top20[i].directory) + strlen(top20[i].filename)- 31);
      top20[i].directory[0]=TOOLONG;
    }

    sprintf(tmp2, "%s/\[1m%s", top20[i].directory, top20[i].filename);
    printf("\[0;%um%-36s \[1;%um%4i \[1;%um%s\[0m\r\n", FILECOL, tmp2, DLCOL, top20[i].downloads, DESCOL, top20[i].desc);
  }
  printf("\r\n");
}
